#include <plib.h>
#include "NU32v2.h"

int main(void) {
  int i = 2;

  SYSTEMConfig(SYS_FREQ, SYS_CFG_ALL);

  // configure for multi-vectored mode
  INTConfigureSystem(INT_SYSTEM_CONFIG_MULT_VECTOR);

  // enable multi-vector interrupts 
  INTEnableSystemMultiVectoredInt(); 

  // initialize serial port and interrupt
  initSerialNU32v2();
    
  initLEDs(); 	// set LED pins as outputs

  WriteString(UART3, "\r\nHello World!\r\n");

  sprintf(RS232_Out_Buffer, "the value of i is: %d\r\n", i);
  WriteString(UART3, RS232_Out_Buffer);

  while(1) {
    // nothing, use the ISR to echo any bytes recieved
  }

  return 0;
} // end main

// UART3 interrupt handler, priority level 2
void __ISR(_UART_3_VECTOR, ipl2) IntUart3Handler(void) {
  // Is this an RX interrupt?
  if(INTGetFlag(INT_SOURCE_UART_RX(UART3))){
    char data = UARTGetDataByte(UART3);

    // Echo what we just received
    PutCharacter(UART3, data); 

    // do something with the data
    if(data =='a') {
      LED0 = 0;  LED1 = 1;
    }
    else {
      LED0 = 1; LED1 = 0;
    }

    // Clear the RX interrupt Flag
    INTClearFlag(INT_SOURCE_UART_RX(UART3)); 
  }

  // We don't care about TX interrupt
  if(INTGetFlag(INT_SOURCE_UART_TX(UART3))) {
    INTClearFlag(INT_SOURCE_UART_TX(UART3));
  }
}
